fixProductionActive = {};

fixProductionActive.metadata = {
	interface = " FS22 ...",
	title = "FixProductionActive",
	notes = " behebt das Problem das die Produktionen Automatisch alle Aktiv sind wenn man diese kauft/platziert oder das Farmland auf dem sie stehen",
	author = " (by HappyLooser)",
	version = " v1.0.0.0",
	datum = " 20.04.2023",
	info = "extern",
};

function fixProductionActive:loadMap()	
	if allreadyExistsOnMap() then
		print("---NOT loading extern mod ".. tostring(fixProductionActive.metadata.title).. tostring(fixProductionActive.metadata.version).. tostring(fixProductionActive.metadata.author).. " (allready exists on Map)---")
	else
		print("---loading ".. tostring(fixProductionActive.metadata.title).. tostring(fixProductionActive.metadata.version).. tostring(fixProductionActive.metadata.author).. "---")
		ProductionPoint.setOwnerFarmId = Utils.overwrittenFunction(ProductionPoint.setOwnerFarmId, fixProductionActive.setOwnerFarmId);
	end;
end;

function allreadyExistsOnMap()	
	if g_currentMission ~= nil and g_currentMission.missionInfo ~= nil and string.find(g_currentMission.missionInfo.map.id, "SampleModMap") then
		local zipName = string.gsub(g_currentMission.missionInfo.map.id, ".SampleModMap", "");
		local env = getfenv(0);
		if env[zipName] ~= nil and env[zipName].fixProductionActive ~= nil then
			return true;
		end;
	end;
	return false;
end;

function fixProductionActive.setOwnerFarmId(self, superFunc, farmId, noEventSend)
	if self.isServer then
		self:claimProductionCosts();
	end;
	g_currentMission.productionChainManager:removeProductionPoint(self);
	ProductionPoint:superClass().setOwnerFarmId(self, farmId, noEventSend);
	self.isOwned = farmId ~= AccessHandler.EVERYONE;	
	if not self.isOwned then
		for _, production in pairs(self.productions) do
			self:setProductionState(production.id, false);
		end;
	end;
	if self.unloadingStation ~= nil then
		self.unloadingStation.skipSell = self.isOwned;
		self.unloadingStation:setOwnerFarmId(farmId);
	end;
	if self.loadingStation ~= nil then
		self.loadingStation:setOwnerFarmId(farmId);
	end;
	if self.storage ~= nil then
		self.storage:setOwnerFarmId(farmId);
	end;
	g_currentMission.productionChainManager:addProductionPoint(self);
end;
addModEventListener(fixProductionActive);